unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, shellapi;

type
  TformMenuPrincipal = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtPuerto: TComboBox;
    Label2: TLabel;
    be: TStatusBar;
    bMarcar: TBitBtn;
    bColgar: TBitBtn;
    bSalir: TBitBtn;
    LWEB: TLabel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    txtNumeroTelefono: TComboBox;
    procedure bColgarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure txtNumeroTelefonoKeyPress(Sender: TObject; var Key: Char);
    procedure bMarcarClick(Sender: TObject);
    procedure bSalirClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

var
  hCommFile : THandle;

function existeTelefono (telefonoComp : string) : Boolean;
var
  telefonos : string;
  listaTelf : TStringList;
  posicion : integer;
begin
  telefonos := ExtractFilePath (Application.ExeName) + 'telefonos.txt';
  listaTelf := TStringList.Create;
  listaTelf.LoadFromFile(telefonos);
  listaTelf.Sort;
  Result := listaTelf.Find(telefonoComp, posicion);
end;


procedure TformMenuPrincipal.bColgarClick(Sender: TObject);
begin
  try
    CloseHandle(hCommFile);
  except
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
var
  telefonos : string;
begin
  telefonos := ExtractFilePath (Application.ExeName) + 'telefonos.txt';
  if FileExists(telefonos) then
    txtNumeroTelefono.Items.LoadFromFile(telefonos);
  txtPuerto.Text := 'COM3';
  if ParamStr(1) <> '' then
    txtNumeroTelefono.Text := ParamStr(1);
  if ParamStr(2) <> '' then
    txtPuerto.Text := UpperCase (ParamStr(2));
  if txtNumeroTelefono.Text <> '' then
    bMarcarClick(Self);
end;

procedure TformMenuPrincipal.txtNumeroTelefonoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
    bMarcarClick(Self);
end;

procedure TformMenuPrincipal.bMarcarClick(Sender: TObject);
var
  numeroTelefono : string;
  puerto : string;
  numeroBytesEscritos : cardinal;
  telefonos : string;
  listaTelefonos : TStringList;
begin
  if not existeTelefono(txtNumeroTelefono.Text) then
  begin
    telefonos := ExtractFilePath (Application.ExeName) + 'telefonos.txt';
    listaTelefonos := TStringList.Create;
    if FileExists(telefonos) then
      listaTelefonos.LoadFromFile(telefonos);
    listaTelefonos.Add (txtNumeroTelefono.Text);
    listaTelefonos.SaveToFile(telefonos);
  end;
  if txtNumeroTelefono.Text = '' then
    MessageDlg('Debe indicar el nmero de telfono fijo o mvil a marcar.',
        mtWarning, [mbok], 0)
  else
  begin
    be.Panels[0].Text := 'Marcando ' + txtNumeroTelefono.Text + '...';
    numeroTelefono := 'ATDT ' + txtNumeroTelefono.text + #13 + #10;
    puerto := txtPuerto.Text;
    hCommFile := CreateFile(PChar(puerto), GENERIC_WRITE, 0, nil, OPEN_EXISTING,
        FILE_ATTRIBUTE_NORMAL, 0);
    if hCommFile = INVALID_HANDLE_VALUE then
    begin
      be.Panels[0].Text := 'Error en la conexin con ' + txtPuerto.Text;
      MessageDlg ('Ha habido un error al intentar abrir el puerto: ' + puerto +
          '. Compruebe que no est siendo utilizado por otra aplicacin ' +
          'y que es el puerto correcto.', mtWarning, [mbok], 0);
    end
    else
    begin
      numeroBytesEscritos := 0;
      if WriteFile (hCommFile, PChar(numeroTelefono)^, Length(numeroTelefono),
          numeroBytesEscritos, nil) = false then
      begin
        be.Panels[0].Text := 'Error en la conexin con ' + txtPuerto.Text;
        MessageDlg ('Ha habido un error al intentar abrir el puerto: ' + puerto +
            '. Compruebe que no est siendo utilizado por otra aplicacin ' +
            'y que es el puerto correcto.', mtWarning, [mbok], 0);
      end
      else
        be.Panels[0].Text := 'Marcacin realizada con xito';
    end;
  end;
end;

procedure TformMenuPrincipal.bSalirClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
